
#ifndef PLS_THREAD_STATE_H
#define PLS_THREAD_STATE_H

#include "abstract_task.h"
#include "pls/internal/base/aligned_stack.h"

namespace pls {
    namespace internal {
        namespace scheduling {
            // forward declaration
            class scheduler;

            struct thread_state {
                scheduler* scheduler_;
                abstract_task* root_task_;
                abstract_task* current_task_;
                base::aligned_stack* task_stack_;
                unsigned int id_;
                base::spin_lock lock_;

                thread_state():
                    scheduler_{nullptr},
                    root_task_{nullptr},
                    current_task_{nullptr},
                    task_stack_{nullptr},
                    id_{0} {};

                thread_state(scheduler* scheduler, base::aligned_stack* task_stack, unsigned int id):
                    scheduler_{scheduler},
                    root_task_{nullptr},
                    current_task_{nullptr},
                    task_stack_{task_stack},
                    id_{id} {}
            };
        }
    }
}

#endif //PLS_THREAD_STATE_H
